using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GenerateTerrain
{
    public partial class Form1 : Form
    {
        //Lagring fr vr horisentallinje
        List<double> HeightMap = new List<double>();
        //Randomerare fr slumptal
        private Random rnd = new Random();
        //Bilden som kommer attt genereras i form av en bitmap
        Bitmap b = new Bitmap(640, 480);

        public Form1()
        {
            InitializeComponent();

            //Frglgger bilden svart vid start
            //
            Graphics g = Graphics.FromImage(b);
            g.Clear(Color.Black);
            pictureBox1.Image = b;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Nollstller listan med punkter
            HeightMap.Clear();

            //Lgger till start- och stop-punkt
            HeightMap.Add(0);
            HeightMap.Add(0);
            
            //Brjar algoritmen med slump +- 1.0
            double Max = 1.0;
            //Bestmmer ojmnheten i terrngen
            double Roughness = ((double)numericUpDown2.Value / 100.0);

            //Generera linjen
            //
            //Uprepa enligt angivet antal iterationer
            for (int j = 0; j < numericUpDown1.Value; j++)
            {
                //Rkna ut hur mnga nya punkter som ska skapas
                int count = HeightMap.Count;
                for (int i = 0; i < count - 1; i++)
                {
                    //Medelvrdet mellan tv punkter
                    double tmp = (HeightMap[i*2] + HeightMap[i*2 + 1]) / 2.0;
                    //Berkna en slumpvis frskjutning +-Max
                    double offset = (rnd.NextDouble() * 2.0 - 1.0) * Max;

                    //Skapa ny punkt med medelvrde + slumvis frskjutning
                    HeightMap.Insert(i * 2 + 1, tmp+offset);
                }
                //Berkna Max fr nsta iteration, avtagande med en faktor 2^(x)
                Max = Max * Math.Pow(2, -Roughness);
            }

            //Frglgg bilden svart (nollstll)
            Graphics g = Graphics.FromImage(b);
            g.Clear(Color.Black);

            //Rendera bilden (640 pixlar bred)
            //
            for (int x = 0; x  <= 639; x++ )
            {
                //Berkna vilken punkt p linjen som ligger nrmast
                double index = (x / 640.0) * (HeightMap.Count-1);
                int start = (int)Math.Floor(index);

                //Interpolera mellan berknad punkt och nsta punkt
                double r2 = index - Math.Floor(index);
                double r1 = 1.0 - r2;
                double height = HeightMap[start] * r1 + HeightMap[start + 1] * r2;

                //Ge linjen en offset p 300 pixlar och en amplitud p 150 pixlar
                Point p1 = new Point(x, (int)(  300 + 150.0 * height));
                Point p2 = new Point(x, 0);
                //Rita vertikalt vitt streck frn horisonten och uppt
                g.DrawLine(Pens.White, p1, p2); 
            }
            //Uppdatera bilden
            pictureBox1.Image = b;
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pictureBox1.Image.Save(saveFileDialog1.FileName); 
            }
        }
    }
}